<?php

namespace Farfetch\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGeoBrandPriceSaveResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfGeoBrandPriceSaveResult extends AbstractStructArrayBase
{
    /**
     * The GeoBrandPriceSaveResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Farfetch\StructType\GeoBrandPriceSaveResult[]
     */
    public $GeoBrandPriceSaveResult;
    /**
     * Constructor method for ArrayOfGeoBrandPriceSaveResult
     * @uses ArrayOfGeoBrandPriceSaveResult::setGeoBrandPriceSaveResult()
     * @param \Farfetch\StructType\GeoBrandPriceSaveResult[] $geoBrandPriceSaveResult
     */
    public function __construct(array $geoBrandPriceSaveResult = array())
    {
        $this
            ->setGeoBrandPriceSaveResult($geoBrandPriceSaveResult);
    }
    /**
     * Get GeoBrandPriceSaveResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Farfetch\StructType\GeoBrandPriceSaveResult[]|null
     */
    public function getGeoBrandPriceSaveResult()
    {
        return isset($this->GeoBrandPriceSaveResult) ? $this->GeoBrandPriceSaveResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGeoBrandPriceSaveResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGeoBrandPriceSaveResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGeoBrandPriceSaveResultForArrayConstraintsFromSetGeoBrandPriceSaveResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGeoBrandPriceSaveResultGeoBrandPriceSaveResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfGeoBrandPriceSaveResultGeoBrandPriceSaveResultItem instanceof \Farfetch\StructType\GeoBrandPriceSaveResult) {
                $invalidValues[] = is_object($arrayOfGeoBrandPriceSaveResultGeoBrandPriceSaveResultItem) ? get_class($arrayOfGeoBrandPriceSaveResultGeoBrandPriceSaveResultItem) : sprintf('%s(%s)', gettype($arrayOfGeoBrandPriceSaveResultGeoBrandPriceSaveResultItem), var_export($arrayOfGeoBrandPriceSaveResultGeoBrandPriceSaveResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GeoBrandPriceSaveResult property can only contain items of type \Farfetch\StructType\GeoBrandPriceSaveResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GeoBrandPriceSaveResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Farfetch\StructType\GeoBrandPriceSaveResult[] $geoBrandPriceSaveResult
     * @return \Farfetch\ArrayType\ArrayOfGeoBrandPriceSaveResult
     */
    public function setGeoBrandPriceSaveResult(array $geoBrandPriceSaveResult = array())
    {
        // validation for constraint: array
        if ('' !== ($geoBrandPriceSaveResultArrayErrorMessage = self::validateGeoBrandPriceSaveResultForArrayConstraintsFromSetGeoBrandPriceSaveResult($geoBrandPriceSaveResult))) {
            throw new \InvalidArgumentException($geoBrandPriceSaveResultArrayErrorMessage, __LINE__);
        }
        if (is_null($geoBrandPriceSaveResult) || (is_array($geoBrandPriceSaveResult) && empty($geoBrandPriceSaveResult))) {
            unset($this->GeoBrandPriceSaveResult);
        } else {
            $this->GeoBrandPriceSaveResult = $geoBrandPriceSaveResult;
        }
        return $this;
    }
    /**
     * Add item to GeoBrandPriceSaveResult value
     * @throws \InvalidArgumentException
     * @param \Farfetch\StructType\GeoBrandPriceSaveResult $item
     * @return \Farfetch\ArrayType\ArrayOfGeoBrandPriceSaveResult
     */
    public function addToGeoBrandPriceSaveResult(\Farfetch\StructType\GeoBrandPriceSaveResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Farfetch\StructType\GeoBrandPriceSaveResult) {
            throw new \InvalidArgumentException(sprintf('The GeoBrandPriceSaveResult property can only contain items of type \Farfetch\StructType\GeoBrandPriceSaveResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GeoBrandPriceSaveResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Farfetch\StructType\GeoBrandPriceSaveResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Farfetch\StructType\GeoBrandPriceSaveResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Farfetch\StructType\GeoBrandPriceSaveResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Farfetch\StructType\GeoBrandPriceSaveResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Farfetch\StructType\GeoBrandPriceSaveResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GeoBrandPriceSaveResult
     */
    public function getAttributeName()
    {
        return 'GeoBrandPriceSaveResult';
    }
}
