<?php

namespace Farfetch\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Associate ServiceType
 * @subpackage Services
 */
class Associate extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named AssociateToChildProduct
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Farfetch\StructType\AssociateToChildProduct $parameters
     * @return \Farfetch\StructType\AssociateToChildProductResponse|bool
     */
    public function AssociateToChildProduct(\Farfetch\StructType\AssociateToChildProduct $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->AssociateToChildProduct($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \Farfetch\StructType\AssociateToChildProductResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
