<?php

namespace Farfetch\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Product ServiceType
 * @subpackage Services
 */
class Product extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named ProductPriceUpdate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Farfetch\StructType\ProductPriceUpdate $parameters
     * @return \Farfetch\StructType\ProductPriceUpdateResponse|bool
     */
    public function ProductPriceUpdate(\Farfetch\StructType\ProductPriceUpdate $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->ProductPriceUpdate($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \Farfetch\StructType\ProductPriceUpdateResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
